<!doctype html>
<!--
    Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 4.8 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="../module1">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="../module1/discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="../module1/get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="../module1/exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module1/introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="./">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">v6.0</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/v6.0">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 4.8: Water lock case requirements and supervisor</h1>
                    <p>
                        In Module 3, you finished the plant model of the Westsluis water lock.
                        Now you'll apply what you've learned in this module, to model the requirement of the Westsluis.
                        And you'll synthesize a supervisor.
                    </p>

                    <h2>Assignment 1</h2>
                    <p>
                        To model the various requirements, create a new CIF file named <code>requirements.cif</code>.
                        In this new file, import the plant model.
                        This allows the requirements to refer to event and locations of the plant.
                    </p>
                    <p>
                        Since the requirements model imports the plant model, it will combine both the plants and the requirements, and will thus form the input for synthesis.
                        For now though, only add the import, but do not yet add any requirements and do not yet perform synthesis.
                    </p>
                    <div class="accordion" id="assignment1-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment1-solution" aria-expanded="false" aria-controls="assignment1-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment1-solution" class="accordion-collapse collapse" data-bs-parent="#assignment1-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>requirements.cif</code> file now contains the following:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            import "plant.cif";
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 2</h2>
                    <p>
                        The lock has various commands that allow the operator to control the it.
                        For instance, the north gate may only be opened after the operator requests it to be opened.
                        A single command may enable events of multiple components.
                        For instance, when the operators clicks the button to open the north traffic barriers, the events to open the north-west and north-east traffic barriers should both be enabled.
                        When a command is activated, the supervisor should ensure the proper control responses, before the plant unrequests the command.
                    </p>
                    <p>
                        Model the requirements for all the commands.
                        Avoid as much as possible duplicating the requirements for the north and south side, as well as for multiple components connected to a single command.
                    </p>
                    <div class="accordion" id="assignment2-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment2-solution" aria-expanded="false" aria-controls="assignment2-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment2-solution" class="accordion-collapse collapse" data-bs-parent="#assignment2-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The <code>requirements.cif</code> file is extended with the following:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group def CommandRequirements(Side side):
                                                requirement side.Gate.Actuator.c_start_opening
                                                            needs side.GateOpenCommand.Requested;
                                                requirement side.Gate.Actuator.c_start_closing
                                                            needs side.GateCloseCommand.Requested;

                                                requirement side.Bridge.Actuator.c_start_opening
                                                            needs side.BridgeOpenCommand.Requested;
                                                requirement side.Bridge.Actuator.c_start_closing
                                                            needs side.BridgeCloseCommand.Requested;

                                                requirement {side.Culverts.East.Actuator.c_start_opening,
                                                             side.Culverts.West.Actuator.c_start_opening}
                                                            needs side.Culverts.OpenCommand.Requested;
                                                requirement {side.Culverts.East.Actuator.c_start_closing,
                                                             side.Culverts.West.Actuator.c_start_closing}
                                                            needs side.Culverts.CloseCommand.Requested;

                                                requirement {side.TrafficBarriers.East.Actuator.c_start_opening,
                                                             side.TrafficBarriers.West.Actuator.c_start_opening}
                                                            needs side.TrafficBarriers.OpenCommand.Requested;
                                                requirement {side.TrafficBarriers.East.Actuator.c_start_closing,
                                                             side.TrafficBarriers.West.Actuator.c_start_closing}
                                                            needs side.TrafficBarriers.CloseCommand.Requested;

                                                requirement {side.EnteringTLs.East.Actuator.c_to_red_red,
                                                             side.EnteringTLs.West.Actuator.c_to_red_red}
                                                            needs side.EnteringTLs.RedRedCommand.Requested;
                                                requirement {side.EnteringTLs.East.Actuator.c_to_red,
                                                             side.EnteringTLs.West.Actuator.c_to_red}
                                                            needs side.EnteringTLs.RedCommand.Requested;
                                                requirement {side.EnteringTLs.East.Actuator.c_to_red_green,
                                                             side.EnteringTLs.West.Actuator.c_to_red_green}
                                                            needs side.EnteringTLs.RedGreenCommand.Requested;
                                                requirement {side.EnteringTLs.East.Actuator.c_to_green,
                                                             side.EnteringTLs.West.Actuator.c_to_green}
                                                            needs side.EnteringTLs.GreenCommand.Requested;

                                                requirement {side.LeavingTLs.East.Actuator.c_to_red,
                                                             side.LeavingTLs.West.Actuator.c_to_red}
                                                            needs side.LeavingTLs.RedCommand.Requested;
                                                requirement {side.LeavingTLs.East.Actuator.c_to_green,
                                                             side.LeavingTLs.West.Actuator.c_to_green}
                                                            needs side.LeavingTLs.GreenCommand.Requested;

                                                requirement {side.BridgeTLs.East.Actuator.c_to_on,
                                                             side.BridgeTLs.West.Actuator.c_to_on}
                                                            needs side.BridgeTLs.OnCommand.Requested;
                                                requirement {side.BridgeTLs.East.Actuator.c_to_off,
                                                             side.BridgeTLs.West.Actuator.c_to_off}
                                                            needs side.BridgeTLs.OffCommand.Requested;
                                            end

                                            NorthCommandRequirements: CommandRequirements(North);
                                            SouthCommandRequirements: CommandRequirements(South);
                                        </code>
                                    </pre>
                                    <p>
                                        We opt for a group definition for the command requirements of each side, to prevent duplication for the two sides.
                                        The definition is parameterized with a component parameter that indicates the <code>side</code> to which the requirements are to be applied.
                                        The definition is instantiated twice, once for the <code>North</code> side and once for the <code>South</code> side.
                                    </p>
                                    <p>
                                        The requirements for the commands are given as state/event exclusion requirements, enabling certain actuator events only if the corresponding command is requested.
                                        In case a single command enables multiple actuator events for multiple components, a single state/event exclusion requirement is used that restricts these events.
                                        Empty lines are used to separate the requirements for the gate, bridge, culverts, traffic barriers, and so on, to increase readability.
                                    </p>
                                    <p>
                                        The supervisor will enable the right controllable events immediately upon a request.
                                        There is no need to handle the unrequesting of commands in the requirements.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 3</h2>
                    <p>
                        In the first module, you <a href="../module1/introduction-to-the-water-lock-case.html#simulation-model">simulated the Westsluis water lock</a>, using models provided as part of the course files.
                        The model did not yet contain a proper controller to ensure safe behavior, allowing you to discover the potential unsafe behaviors of the system through simulation.
                        The model that you simulated, did however already contain a supervisor synthesized from the plant model and command requirements.
                        By including the connection between the commands and their effect on the system, you were able to manually control the system, and identify its unsafe behavior.
                    </p>
                    <p>
                        Let's recreate that simulation, step by step.
                    </p>
                    <p>
                        <strong>a. Synthesize a partially-supervised supervisor from the plant and requirement models you've created so far.</strong>
                    </p>
                    <p>
                        To prevent having to click through various menus and configure all settings every time again, you can use a ToolDef script.
                        ToolDef is a cross-platform scripting language, and among others allows you to easily script CIF tools.
                        Create a file named <code>synthesize.tooldef</code> that contains a script to automatically synthesize the supervisor:
                    </p>
                    <pre class="highlightjs highlight">
                        <code class="language-tooldef hljs" data-lang="tooldef">
                            from "lib:cif" import *;

                            cifdatasynth(
                                "requirements.cif",
                                "--output=lock.cif",
                            );
                        </code>
                    </pre>
                    <p>
                        This script first imports all CIF tools, from the library of CIF tools.
                        It then starts data-based synthesis, using <code>requirements.cif</code> as input model.
                        Remember that this file contains the plants and the requirements.
                        The output of synthesis is written to a file named <code>lock.cif</code>.
                    </p>
                    <p>
                        Remember that you can execute a ToolDef script by right-clicking it and choosing <em>Execute ToolDef</em>, or by pressing <kbd>F10</kbd> while the ToolDef file is selected in the <em>Project Explorer</em>.
                    </p>
                    <p>
                        <strong>b. Copy the simulation files from the Module 1 course files.</strong>
                    </p>
                    <p>
                        Copy <code>lock.svg</code>, the SVG image of the Westsluis water lock.
                    </p>
                    <p>
                        Also copy the <code>simulation.cif</code> file, the file that contains the simulation model.
                        Inspect the simulation model, to see whether you understand it.
                        You may see some continuous variables (keyword <code>cont</code>) and equations (keyword <code>equation</code>), that will be explained in the next module.
                    </p>
                    <p>
                        Finally, copy the <code>simulate.tooldef</code> file, the script to start the simulation.
                        Inspect the file, and make sure you understand it.
                        If needed, start the simulator to show its option dialog, by right-clicking the <code>simulation.cif</code> file and choosing the appropriate menu items.
                        In the option dialog, select <em>Command line options</em> from the <em>Help</em> category.
                        It lists the various options that can be used on the command line, as well as in ToolDef scripts, as well as their syntax.
                        Don't actually start the simulation, but instead press <em>Cancel</em> to close the option dialog.
                    </p>
                    <p>
                        <strong>c. Simulate the partially-controlled system.</strong>
                    </p>
                    <p>
                        Start the simulation by running the simulation ToolDef script.
                        Check that the behavior is still the same as it was in Module 1.
                    </p>

                    <h2>Assignment 4</h2>
                    <p>
                        The partially-controlled Westsluis is not yet safe.
                        Before modeling safety requirements, it is good to first think of what the desired behavior of the system is, and which requirements are needed to ensure that only this desired behavior is possible.
                    </p>
                    <p>
                        Draw on paper an operation cycle for one side of the lock, that ensures that the lock operates safely.
                        This cycle should ensure that the lock transitions safely from a state where the road traffic can drive over the bridge to a state where the water traffic can leave or enter the lock, and can safely transition back.
                        Which sequences of actions should be taken to achieve this?
                        Leave out the culverts for now.
                        And for the entering traffic lights, consider only the red and green lights, leaving out red/red and red/green for now.
                        Also, remember that in the initial state of the plant model, road traffic is allowed to cross the bridge and water traffic is not permitted to enter or exit the lock.
                    <p>
                    <div class="accordion" id="assignment4-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment4-solution" aria-expanded="false" aria-controls="assignment4-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment4-solution" class="accordion-collapse collapse" data-bs-parent="#assignment4-accordion">
                                <div class="accordion-body">
                                    <p>
                                        As usual, when designing a controller there is not one correct behavior of the system.
                                        Choices can be made, and the following is just one of the options:
                                    </p>
                                    <img src="images/assignment4.png">
                                    <p>
                                        Initially, road traffic is allowed over the bridge.
                                        The bridge traffic lights at both sides the bridge are turned on, to indicate that bridge traffic should stop using the bridge.
                                        The traffic barriers on both sides of the bridge are then closed, the bridge is then opened, the gate is opened, and the entering or leaving traffic lights are turned green.
                                        Water traffic is then allowed to enter or exit the lock.
                                        This completes the downward path of the cycle.
                                    </p>
                                    <p>
                                        The upward path of the cycle is similar, but in reverse, and turns the entering or leaving traffic lights to red instead of green, closes the gate instead of opening it, and so on.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 5</h2>
                    <p>
                        We add the requirements step by step, following at the same time both paths of the operation cycle, from top to bottom.
                        We thus consider the left path from start to finish, and the right path in reverse order.
                        We start at the top, so with the bridge traffic lights.
                    </p>
                    <p>
                        Simulate again the partially-controlled system, and check what behavior is possible for the bridge traffic lights.
                        And then think of what the desired behavior is.
                        In which states is it allowed and desired to turn the bridge lights on or off, and in which states is it not allowed?
                    </p>
                    <p>
                        Model these safety requirements as state/event exclusion requirements.
                    </p>
                    <div class="accordion" id="assignment5-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment5-solution" aria-expanded="false" aria-controls="assignment5-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment5-solution" class="accordion-collapse collapse" data-bs-parent="#assignment5-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Turning on the bridge traffic lights is the start of the left path, and does not any restrictions.
                                        Turning off the bridge traffic lights should only be allowed if the traffic barriers are open.
                                        This can be modeled with state/event exclusion invariants as follows:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group BridgeTLRequirements:
                                                requirement {North.BridgeTLs.East.Actuator.c_to_off,
                                                             North.BridgeTLs.West.Actuator.c_to_off}
                                                            needs North.TrafficBarriers.IsOpen;
                                                requirement {South.BridgeTLs.East.Actuator.c_to_off,
                                                             South.BridgeTLs.West.Actuator.c_to_off}
                                                            needs South.TrafficBarriers.IsOpen;
                                            end
                                        </code>
                                    </pre>
                                    <p>
                                        We again combine requirements with the same conditions.
                                        We do not use component definition/instantiation, since the overhead would be bigger than the gain, as the definition would only contain a single state/event exclusion requirement.
                                        We do add a named group around the requirements, for readability of the model.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 6</h2>
                    <p>
                        The next step is to add safety requirements for the traffic barriers.
                        Think again about the states in which they should and may not be opened and closed.
                        And then model the requirements.
                    </p>
                    <div class="accordion" id="assignment6-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment6-solution" aria-expanded="false" aria-controls="assignment6-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment6-solution" class="accordion-collapse collapse" data-bs-parent="#assignment6-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Closing the traffic barriers should only be done once the traffic bridge lights are on.
                                        Opening the traffic barriers should only be done once the bridge is closed.
                                        This can be modeled with state/event exclusion invariants as follows:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group TrafficBarrierRequirements:
                                                requirement {North.TrafficBarriers.East.Actuator.c_start_closing,
                                                             North.TrafficBarriers.West.Actuator.c_start_closing}
                                                            needs North.BridgeTLs.IsOn;
                                                requirement {South.TrafficBarriers.East.Actuator.c_start_closing,
                                                             South.TrafficBarriers.West.Actuator.c_start_closing}
                                                            needs South.BridgeTLs.IsOn;

                                                requirement {North.TrafficBarriers.East.Actuator.c_start_opening,
                                                             North.TrafficBarriers.West.Actuator.c_start_opening}
                                                            needs North.Bridge.IsClosed;
                                                requirement {South.TrafficBarriers.East.Actuator.c_start_opening,
                                                             South.TrafficBarriers.West.Actuator.c_start_opening}
                                                            needs South.Bridge.IsClosed;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 7</h2>
                    <p>
                        Add the safety requirements for the bridge.
                    </p>
                    <div class="accordion" id="assignment7-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment7-solution" aria-expanded="false" aria-controls="assignment7-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment7-solution" class="accordion-collapse collapse" data-bs-parent="#assignment7-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Opening the bridge should only be done once the traffic barriers are closed.
                                        Closing the bridge should only be done once the gate is closed.
                                        This can be modeled with state/event exclusion invariants as follows:
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group BridgeRequirements:
                                                requirement North.Bridge.Actuator.c_start_opening needs North.TrafficBarriers.IsClosed;
                                                requirement South.Bridge.Actuator.c_start_opening needs South.TrafficBarriers.IsClosed;

                                                requirement North.Bridge.Actuator.c_start_closing needs North.Gate.IsClosed;
                                                requirement South.Bridge.Actuator.c_start_closing needs South.Gate.IsClosed;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 8</h2>
                    <p>
                        Add the safety requirements for the gate.
                        Consider for this also the states of the culverts, entering traffic lights and leaving traffic lights.
                    </p>
                    <div class="accordion" id="assignment8-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment8-solution" aria-expanded="false" aria-controls="assignment8-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment8-solution" class="accordion-collapse collapse" data-bs-parent="#assignment8-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Opening a gate should only be done once the bridge is closed.
                                        To prevent floods, we also require that the gate and culverts at the other side are closed.
                                    </p>
                                    <p>
                                        Closing a gate should only be done once the entering and leaving traffic lights have been turned to red.
                                        For the entering traffic lights, out of service (red/red) should be taken into account as well.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group GateRequirements:
                                                requirement North.Gate.Actuator.c_start_opening
                                                            needs North.Bridge.IsOpen and South.Gate.IsClosed and South.Culverts.IsClosed;
                                                requirement South.Gate.Actuator.c_start_opening
                                                            needs South.Bridge.IsOpen and North.Gate.IsClosed and North.Culverts.IsClosed;

                                                requirement North.Gate.Actuator.c_start_closing
                                                            needs (North.EnteringTLs.IsRed or North.EnteringTLs.IsRedRed)
                                                              and North.LeavingTLs.IsRed;
                                                requirement South.Gate.Actuator.c_start_closing
                                                            needs (South.EnteringTLs.IsRed or South.EnteringTLs.IsRedRed)
                                                              and South.LeavingTLs.IsRed;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 9</h2>
                    <p>
                        Add the safety requirements for the culverts.
                    </p>
                    <div class="accordion" id="assignment9-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment9-solution" aria-expanded="false" aria-controls="assignment9-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment9-solution" class="accordion-collapse collapse" data-bs-parent="#assignment9-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The culverts may only be opened if on the other side the culverts and gate are closed.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group CulvertRequirements:
                                                requirement {North.Culverts.East.Actuator.c_start_opening,
                                                             North.Culverts.West.Actuator.c_start_opening}
                                                            needs South.Culverts.IsClosed and South.Gate.IsClosed;
                                                requirement {South.Culverts.East.Actuator.c_start_opening,
                                                             South.Culverts.West.Actuator.c_start_opening}
                                                            needs North.Culverts.IsClosed and North.Gate.IsClosed;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 10</h2>
                    <p>
                        Add the safety requirements for the leaving traffic lights.
                    </p>
                    <div class="accordion" id="assignment10-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment10-solution" aria-expanded="false" aria-controls="assignment10-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment10-solution" class="accordion-collapse collapse" data-bs-parent="#assignment10-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The leaving traffic lights may only be set to green if the gate is open and the entering traffic lights are either red or red/red.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            group LeavingTLRequirements:
                                                requirement {North.LeavingTLs.East.Actuator.c_to_green,
                                                             North.LeavingTLs.West.Actuator.c_to_green}
                                                            needs North.Gate.IsOpen
                                                              and (North.EnteringTLs.IsRed or North.EnteringTLs.IsRedRed);
                                                requirement {South.LeavingTLs.East.Actuator.c_to_green,
                                                             South.LeavingTLs.West.Actuator.c_to_green}
                                                            needs South.Gate.IsOpen
                                                              and (South.EnteringTLs.IsRed or South.EnteringTLs.IsRedRed);
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Assignment 11</h2>
                    <p>
                        And finally, add the safety requirements for the entering traffic lights.
                        Carefully consider the order in which the lights change color, and from what color they may change to what other color.
                        Hint: Besides state/event exclusion requirements, also use requirement automata.
                    </p>
                    <div class="accordion" id="assignment11-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment11-solution" aria-expanded="false" aria-controls="assignment11-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment11-solution" class="accordion-collapse collapse" data-bs-parent="#assignment11-accordion">
                                <div class="accordion-body">
                                    <p>
                                        The requirement automaton definition indicates the allowed order of color changes.
                                        We instantiate it once for each of the four leaving traffic lights.
                                    </p>
                                    <p>
                                        The entering traffic lights are initially red.
                                        To become green, they should first become red/green for a bit.
                                        Once they are green, they can become red again.
                                        Only if they are red, may they become red/red.
                                        It is always possible to become red.
                                    </p>
                                    <p>
                                        Leaving traffic lights may only be turned to green once the gate is open and the leaving traffic lights are red.
                                    </p>
                                    <pre class="highlightjs highlight">
                                        <code class="language-cif hljs" data-lang="cif">
                                            requirement def EnteringTLOrder(controllable c_to_red_red, c_to_red, c_to_red_green, c_to_green):
                                                location Red:
                                                    initial;
                                                    marked;
                                                    edge c_to_red_red   goto RedRed;
                                                    edge c_to_red_green goto RedGreen;

                                                location RedRed:
                                                    marked;
                                                    edge c_to_red       goto Red;

                                                location RedGreen:
                                                    edge c_to_red       goto Red;
                                                    edge c_to_green     goto Green;

                                                location Green:
                                                    edge c_to_red       goto Red;
                                            end

                                            group EnteringTLRequirements:
                                                NorthEastOrder: EnteringTLOrder(
                                                        North.EnteringTLs.East.Actuator.c_to_red_red,
                                                        North.EnteringTLs.East.Actuator.c_to_red,
                                                        North.EnteringTLs.East.Actuator.c_to_red_green,
                                                        North.EnteringTLs.East.Actuator.c_to_green);
                                                NorthWestOrder: EnteringTLOrder(
                                                        North.EnteringTLs.West.Actuator.c_to_red_red,
                                                        North.EnteringTLs.West.Actuator.c_to_red,
                                                        North.EnteringTLs.West.Actuator.c_to_red_green,
                                                        North.EnteringTLs.West.Actuator.c_to_green);
                                                SouthEastOrder: EnteringTLOrder(
                                                        South.EnteringTLs.East.Actuator.c_to_red_red,
                                                        South.EnteringTLs.East.Actuator.c_to_red,
                                                        South.EnteringTLs.East.Actuator.c_to_red_green,
                                                        South.EnteringTLs.East.Actuator.c_to_green);
                                                SouthWestOrder: EnteringTLOrder(
                                                        South.EnteringTLs.West.Actuator.c_to_red_red,
                                                        South.EnteringTLs.West.Actuator.c_to_red,
                                                        South.EnteringTLs.West.Actuator.c_to_red_green,
                                                        South.EnteringTLs.West.Actuator.c_to_green);

                                                requirement {North.EnteringTLs.East.Actuator.c_to_green,
                                                             North.EnteringTLs.West.Actuator.c_to_green}
                                                            needs North.Gate.IsOpen and North.LeavingTLs.IsRed;
                                                requirement {South.EnteringTLs.East.Actuator.c_to_green,
                                                             South.EnteringTLs.West.Actuator.c_to_green}
                                                            needs South.Gate.IsOpen and South.LeavingTLs.IsRed;
                                            end
                                        </code>
                                    </pre>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Reflection on the requirements</h2>
                    <p>
                        The various requirements fulfill different purposes:
                    </p>
                    <ul>
                        <li>The command requirements ensure the connection between the commands and their effects on the system.</li>
                        <li>The bridge traffic light, traffic barrier, bridge, gate, culvert, leaving traffic light and entering traffic light requirements ensure the proper safe cycle of the system.</li>
                        <li>The gate and culvert requirements additionally ensure that no floods can occur.</li>
                        <li>The entering and leaving traffic light requirements additionally ensure that they are not simultaneously green.</li>
                        <li>The entering traffic light requirements additionally ensure that the entering traffic lights change their color in the right order.</li>
                    </ul>

                    <h2>Assignment 12</h2>
                    <p>
                        Now that the requirements are complete, it is time to synthesize a supervisor.
                        Execute the <code>synthesize.tooldef</code> script and wait for it to finish.
                        Depending on how fast your computer is, this should take only one or a few seconds.
                    </p>
                    <p>
                        Then simulate the fully controlled system using the <code>simulate.tooldef</code> script.
                        Check that it is indeed safe in all situations.
                    </p>
                    <div class="accordion" id="assignment12-accordion">
                        <div class="accordion-item">
                            <h2 class="accordion-header">
                                <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#assignment12-solution" aria-expanded="false" aria-controls="assignment12-solution">
                                    Show solution
                                </button>
                            </h2>
                            <div id="assignment12-solution" class="accordion-collapse collapse" data-bs-parent="#assignment12-accordion">
                                <div class="accordion-body">
                                    <p>
                                        Assuming you did everything correctly, you should observe that the system is now safe.
                                        For instance, you cannot open two opposite gates, nor can you close the traffic barriers when the bridge lights are not on.
                                    </p>
                                </div>
                            </div>
                        </div>
                    </div>

                    <h2>Final remarks</h2>
                    <p>
                        You've completed the plants and requirements for the Westsluis water lock, and you've synthesized a supervisor for it.
                        Congratulations!
                    </p>
                    <p>
                        In the next module, we will add timing to the simulation model.
                        That way, opening a gate is not instantaneous, but takes some time, like in the real system.
                    </p>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="exercises.html">Go back to Module 4.7</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="../module5">Proceed to Module 5</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2024 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
